package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.pojo.mes.bean.MesProductionRecord;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Description : 生产加工记录接口
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/20 21:05
 * @Modify:
 **/
public interface IMesProductionRecordService {

    /**
     * 校验条码加工记录时效性
     * @param productSn 条码 用于查询生产加工记录
     * @param sourceId 用于获取时效性记录
     * @param dataSource 判断是否是装配件校验,如果是装配件校验，不仅需要校验主条码,也需要校验主条码的装配件时效性
     *
     *         MesExtEnumUtil.TIME_DATA_SOURCE
     *         DATA_SOURCE10(10, "排序加工规则"),
     *         DATA_SOURCE20(20, "非排序加工规则"),
     *         DATA_SOURCE30(30, "非排序装配件");
     *
     */
    Map<String, Object> checkSnTimeliness(String organizeCode, String productSn, Long sourceId, Integer dataSource);

    @ApiOperation(value = "根据零件条码查询加工记录信息")
    List<MesProductionRecord> findProductionRecordList(String organizeCode, String productSn);

    @ApiOperation(value = "根据零件条码,物料编码,工序代码,工艺代码查询加工记录信息")
    List<MesProductionRecord> findProductionRecordList(String organizeCode, String productSn, String partNo, String processCode, String craftCode);

    @ApiOperation(value = "根据零件条码,物料编码,工序代码,工艺代码查询加工记录信息")
    List<MesProductionRecord> findProductionRecordList(String organizeCode, String productSn, String partNo, String craftCode);

    void updateProductionRecord(String organizeCode, String userName, String sn);

    void updateProductionRecord(String organizeCode, String userName, Long id, String errorMsg);
}
